#include <cstdio>

const long long MOD = 1000000007;
const int MAX = 1000005;
int T, N, M, K;

long long fact[MAX], ifact[MAX];
long long dp[1001][1001];
int last[MAX];

int main()
{
	
	dp[0][0] = 1;
	for (int i = 0; i < 1000; i++)
	for (int j = 0; j <= i; j++)
	{
		// cook a dish which has been cooked before.
		dp[i+1][j] += dp[i][j] * j % MOD;
		if (dp[i+1][j] >= MOD)
			dp[i+1][j] -= MOD;
		
		// cook a new type of dish.
		if (j < 1000)
			dp[i+1][j+1] += dp[i][j];
		if (dp[i+1][j+1] >= MOD)
			dp[i+1][j+1] -= MOD;
	}
	
	fact[0] = 1;
	for (int i = 1; i <= 1000000; i++)
		fact[i] = (i * fact[i-1]) % MOD;
	
	for (int i = 2; i <= 1000; i++) if (!last[i])
		for (int j = i*i; j <= 1000000; j += i)
			last[j] = i;
	
	for (int i = 1; i <= 1000000; i++)
	{
		if (last[i])
		{
			ifact[i] = ifact[last[i]] * ifact[i/last[i]] % MOD;
			continue;
		}
		long long n = i;
		int p = MOD-2;
		long long r = 1;
		for (; p; p >>= 1)
		{
			if (p & 1)
				r = (r*n) % MOD;
			n = (n*n) % MOD;
		}
		ifact[i] = r;
	}
	
	ifact[0] = 1;
	for (int i = 1; i <= 1000000; i++)
		ifact[i] = (ifact[i-1] * ifact[i]) % MOD;
	
	scanf("%d", &T);
	while (T--)
	{
		scanf("%d%d%d", &N, &M, &K);
		
		long long res = 0;
		for (int j = 1; j <= K && j <= M; j++)
		{
			long long cur = 1;
			cur = (cur * dp[N][j]) % MOD;
			cur = (cur * fact[M]) % MOD;
			cur = (cur * ifact[M-j]) % MOD;
			
			res += cur;
			if (res >= MOD)
				res -= MOD;
		}
		printf("%lld\n", res);
	}
}
